# apply_test.py
import time
from multiprocessing import Pool


def f():
    start = time.time()
    time.sleep(2)
    end = time.time()
    return end - start

p = Pool(processes=1)

# apply function

result = p.apply(f)  # blocking
print ("apply is blocking")
print ('total time', result)

# apply_async function
result = p.apply_async(f)  # non-blocking
print ("apply_async is non-blocking")
while not result.ready():
    time.sleep(0.5)
    print ('working on whatever else I want...')
print ('total time', result.get())  # but get() is blocking
